<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "partner_provider_stats".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "PartnerProviderStats".
 *
 * Columns in table "partner_provider_stats" available as properties of the model,
 * followed by relations of table "partner_provider_stats" available as properties of the model.
 *
 * @property integer $id
 * @property integer $partner_site_id
 * @property integer $provider_id
 * @property integer $tracking_activity_type_id
 * @property string $stats_date
 * @property integer $actions
 * @property string $date_added
 * @property string $date_updated
 *
 * @property PartnerSite $partnerSite
 * @property Provider $provider
 * @property TrackingActivityType $trackingActivityType
 */
abstract class BasePartnerProviderStats extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'partner_provider_stats';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'PartnerProviderStats|PartnerProviderStats', $n);
    }

    public static function representingColumn()
    {
        return 'stats_date';
    }

    public function rules()
    {
        return array(
            array('partner_site_id, provider_id, tracking_activity_type_id, stats_date, actions', 'required'),
            array('partner_site_id, provider_id, tracking_activity_type_id, actions', 'numerical', 'integerOnly'=>true),
            array('date_added, date_updated', 'safe'),
            array('date_added, date_updated', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, partner_site_id, provider_id, tracking_activity_type_id, stats_date, actions, date_added, date_updated', 'safe', 'on'=>'search'),
        );
    }

    public function relations()
    {
        return array(
            'partnerSite' => array(self::BELONGS_TO, 'PartnerSite', 'partner_site_id'),
            'provider' => array(self::BELONGS_TO, 'Provider', 'provider_id'),
            'trackingActivityType' => array(self::BELONGS_TO, 'TrackingActivityType', 'tracking_activity_type_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'partner_site_id' => null,
            'provider_id' => null,
            'tracking_activity_type_id' => null,
            'stats_date' => Yii::t('app', 'Stats Date'),
            'actions' => Yii::t('app', 'Actions'),
            'date_added' => Yii::t('app', 'Date Added'),
            'date_updated' => Yii::t('app', 'Date Updated'),
            'partnerSite' => null,
            'provider' => null,
            'trackingActivityType' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('partner_site_id', $this->partner_site_id);
        $criteria->compare('provider_id', $this->provider_id);
        $criteria->compare('tracking_activity_type_id', $this->tracking_activity_type_id);
        $criteria->compare('stats_date', $this->stats_date, true);
        $criteria->compare('actions', $this->actions);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('date_updated', $this->date_updated, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }

}
